# -.- coding: utf-8 -.-

# Teamgeist
#
# Copyright (C) 2009 Collabora Limited
# *  Contact: Youness Alaoui
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# * Contributors:
# *   Youness Alaoui, Collabora Ltd.



import logging
from utils import do_reply
logger = logging.getLogger('teamgeist.signals')

class SignalDispatcher(object):
    def __init__(self):
        self._callbacks = {}

    def connect(self, signal, callback):
        self._callbacks.setdefault(signal, []).append(callback)

    def disconnect(self, signal, callback):
        callbacks = self._callbacks.setdefault(signal, [])
        if callback in callbacks:
            self._callbacks.setdefault(signal, []).remove(callback)

    def emit_signal(self, signal, *args):
        logger.info("Emitting signal %r : %r" % (signal, args))
        callbacks = self._callbacks.setdefault(signal, [])
        for callback in callbacks:
            do_reply(callback, *((self,) + args))
