'''
Created on Jul 21, 2010

@author: seif
'''
import gtk
import gobject
import pango    
from dbus_objects import TeamgeistService
from teamgeist import *
from ui_utils import *
from datasink import SUPPORTED_SOURCES

TGS = TeamgeistService()
TG = TGS.teamgeist

import zeitgeist
from zeitgeist.client import ZeitgeistClient
from zeitgeist.datamodel import Event, Subject, Interpretation, Manifestation, \
    ResultType, TimeRange

ZG = ZeitgeistClient()

class Window(gtk.Window):
    def __init__(self):
        gtk.Window.__init__(self)
        
        self._init_zeitgeist()
        self.set_size_request(640, 480)
        #self.accountlist = AccountList()
        #self.add(self.accountlist)
        #self.set_account_list()
        self.show_all()
        self.account = None
        self.team = None
        self.topic = None
        self.set_test_env(self.on_test_env_set)
        
    def _init_view(self):
        self.activity_view = ActivityView()
        scroll = gtk.ScrolledWindow()
        viewport = gtk.Viewport()
        viewport.add(self.activity_view)
        scroll.add(viewport)
        scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        viewport.set_shadow_type(gtk.SHADOW_NONE)
        self.add(scroll)
        self.activity_view.set_self_view(self.account)
        scroll.show_all()
        self.show_all()
        
    def _init_zeitgeist(self):
        def notify_insert_handler(time, event):
            event = event[0]
            def reply(bool):
                pass
            def error(e):
                print "ERROR", e
                
            r_event = RemoteEvent(self.team, self.account._uid, str(event.timestamp), event.id,
                 str(event.timestamp), event.interpretation, event.manifestation,
                 event.actor, event.payload, event.subjects)
            self.team.MatchEvent(r_event, reply, error)
        def notify_delete_handler(time, event):
            pass
        ev = Event()
        ZG.install_monitor(TimeRange.always(), [ev], 
                           notify_insert_handler, notify_delete_handler)
        
    def on_test_env_set(self, bool):
        if bool:
            self.team.connect("EventReceived", self.on_event_recieved)
            self.team.connect("EventShared", self.on_event_shared)
            self._init_view()
        
    def on_event_recieved(self, team, member, event):
        print "RECEIVED:", type(member), type(event)
        self.activity_view.insert_event(member, event)
        
    def on_event_shared(self, x, y):
        print "SHARED:", type(x), type(y)
        self.activity_view.insert_event(self.account, y)
    
    def set_account_list(self):
        def error(error):
            print error
        def reply(accounts):
            for account in accounts:
                self.accountlist.add_item(account)
        TG.ListAccounts(reply, error)
    
    def set_test_env(self, callback):
        self.iterating = True
        def error(error):
            print "ERROR: ", error
            callback(False)
        def reply(accounts):
            self.accounts = accounts
            for account in accounts:
                def reply1(name):
                    print "*** Account to use: ", name
                    def reply1_1(connection):
                        print  "*** Connected to: ", connection
                        self.iterating = False
                        def reply2(teams):
                            print  "*** Available Teams: ", teams
                            def reply2_1(j):
                                print  "*** Chose Team:", j
                                self.team = j
                                def reply3(team):
                                    print "*** Team online", team
                                    def reply4(topics):
                                        print "*** Topics available: ", topics
                                        def reply5(topic):
                                            print "*** Selected Topic: ", topic
                                            self.topic = topic
                                            callback(True)
                                        if len(topics) > 0:
                                            reply5(topics[0])
                                        else:
                                            c = [('actor', 2, 'application://gedit')]
                                            j.AddTopic("testing", c, reply5, error )
                                    j.ListTopics(reply4, error)
                                j.JoinTeam(reply3, error)
                            if len(teams) == 0: 
                                TG.AddTeam(name, "xmpp_muc", "test-gedit@conference.jabber.org", reply2_1, error)
                            else: 
                                print "team exists"
                                self.team = Team(TG, 1, self.account, "xmpp_muc", "test-gedit@conference.jabber.org", 1)
                                reply2_1(self.team)
                        TG.ListTeams(reply2, error)
                    for account in self.accounts:
                        account.GetConnection(reply1_1, error)
                        if not self.iterating:
                            break
                def connection(acc, c):
                    if c is not None:
                        print "Connection is %s for account %s" % (c, acc)
                        self.account = acc
                        acc.GetNormalizedName(reply1, error)
                account.GetConnection((connection, account), error)
        import time
        time.sleep(2)
        TG.ListAccounts(reply, error)

class ActivityView(gtk.HBox):
    def __init__(self):
        gtk.HBox.__init__(self)
        self.ppl = {}
        self.ppl_events = {}
        self.account = None
        
    def insert_event(self, member, event):
        def error(e):
            print "Error:", e
        def _do_stuff(uid):
            if not self.ppl.has_key(uid):
                self.ppl[uid] = ContactView(member)
                self.pack_start(self.ppl[uid], True, True, 3)
            
            if not self.ppl_events.has_key(uid):
                self.ppl_events[uid] = {}
            try:
                self.ppl_events[uid][event.subjects[0].uri] = event
            except:
                self.ppl_events[uid][event.subjects[0].id] = event
            self.ppl[uid].set_events(self.ppl_events[uid])
        
        print "****************",  member, self.account
        if member == self.account:
            uid = member.GetUID()
            print uid
            _do_stuff(uid)
        else:
            print member
            member.GetUID(_do_stuff, error)
        
        self.show_all()
        
    def set_self_view(self, account):
        self.account = account
        self.ppl[account.GetUID()] = ContactView(account)
        self.pack_start(self.ppl[account.GetUID()], True, True, 3)
        self.show_all()

class ContactView(gtk.Notebook):
    def __init__(self, contact):
        gtk.Notebook.__init__(self)
        self.items = {}
        self.contact = contact
        self.set_size_request(300,-1)
        self.label = gtk.Label()
        self.view = TreeView()
        self.append_page(self.view,self.label)
        self.set_tab_label_packing(self.view, True, True, gtk.PACK_START)
        def set_name(name):
            self.label.set_text(name)
        def error(e):
            print e
        try:
            self.contact.GetDisplayName(set_name, error)
        except:
            self.contact.GetAlias(set_name, error)
        self.show_all()
        
    def set_events(self, events):
        self.view.clear()
        self.items = events
        for event in self.items.values():
            self.view.add_item(event, 16)
        
        
class TreeView(gtk.TreeView):
    def __init__(self):
        gtk.TreeView.__init__(self)
        self.model = gtk.ListStore(gtk.gdk.Pixbuf, str, gobject.TYPE_PYOBJECT)
        
        self.icon_cell = gtk.CellRendererPixbuf()
        self.icon_cell.set_property("xalign", 0.5)
        self.icon_cell.set_property("yalign", 0.5)
        icon_column = gtk.TreeViewColumn()
        icon_column.pack_start(self.icon_cell)
        icon_column.add_attribute(self.icon_cell, "pixbuf", 0)
        
        self.text_cell = gtk.CellRendererText()
        self.text_cell.set_property("yalign", 0.5)
        self.text_cell.set_property("xalign", 0.0)
        self.text_cell.set_property("ellipsize", pango.ELLIPSIZE_END)
        text_column = gtk.TreeViewColumn()
        text_column.pack_start(self.text_cell, expand=True)
        #self.text_cell.set_fixed_size(128, -1)
        text_column.add_attribute(self.text_cell, "text", 1)
                
        self.append_column(icon_column)
        self.append_column(text_column)
                
        self.use_cells = isinstance(self, gtk.CellLayout)
        self.set_double_buffered(True)
        self.set_reallocate_redraws(True)
        self.set_resize_mode(gtk.RESIZE_IMMEDIATE)
        self.set_model(self.model)
        self.set_rules_hint(True)
        self.set_grid_lines(gtk.TREE_VIEW_GRID_LINES_NONE)
        self.set_headers_visible(False)
        self.connect("row-activated", self.launch)
        self.items = []
        
        self.show_all()
        
        
    def set_files(self, widget, files):
        self.clear()
        for file in files:
            self.add_item(file, 32)
        
    def launch(self, view, path, w):
        item = self.model[path][2]
        launch.launch_uri(item.uri)
        
    def clear(self):
        self.model.clear()
    
    def add_item(self, item, icon_size):
        #item = ITEM_CACHE[item]
        item = item.subjects[0]
        text = item.text
        print text
        def match_interpretation(interpretation):
            if interpretation == Interpretation.MUSIC_PIECE:
                return Interpretation.AUDIO
            elif interpretation == Interpretation.SOURCE_CODE:
                return Interpretation.DOCUMENT
            else:
                return interpretation
        item.interpretation = match_interpretation(item.interpretation)
    
        icon = icon_factory.load_icon(SUPPORTED_SOURCES[item.interpretation]["icon"], 24, True)

        text = text.replace("%20", " ")
        text = text.replace("%5B", "["); text = text.replace("%5D", "]")
        self.model.append([icon, text, item])
        
        
if __name__=="__main__":
    window = Window()
    gtk.main()
