# -.- coding: utf-8 -.-

# Teamgeist
#
# Copyright (C) 2009 Collabora Limited
# *  Contact: Youness Alaoui
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# * Contributors:
# *   Youness Alaoui, Collabora Ltd.



def do_reply(reply_handler, *args):
    """
    Utility function to ease calling of callbacks
    Can take a method, or a tuple of (method, *args)
    It will call the callback (and its optional arguments)
    and append the arguments to this function to it.
    """
    if reply_handler is not None:
        if isinstance(reply_handler, tuple):
            reply_handler[0](*(reply_handler[1:] + args))
        else:
            reply_handler(*args)
